import 'package:flutter/material.dart';

// ignore: must_be_immutable

// ignore: must_be_immutable
class HMTextButton extends StatelessWidget {
  /// Action when the button is being pressed
  final Function onPressed;

  /// The child of the button, usually Icon+Text, Text, Loading+Text.
  final Widget child;

  /// Width of the button
  late double? width;

  /// Height of the button
  late double? height;

  /// Text color of the button, default is HarmonyOS Blue.
  late Color textColor;

  /// Border radius of the button, default is 25.
  late double borderRadius;

  /// Center the child.
  late bool center;

  /// Textbutton following HarmonyOS Design language
  ///
  // ignore: deprecated_member_use
  /// Replaces [FlatButton] and [TextButton] in Material Desingn.
  /// [HMTextButton] is commonly used in [Dialogs]([showHMDialog]) if you follow the HarmonyOS Design.
  HMTextButton({
    Key? key,
    required this.onPressed,
    required this.child,
    this.width,
    this.height,
    this.textColor = const Color.fromARGB(255, 10, 89, 247),
    this.borderRadius = 25,
    this.center = true,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return SizedBox(
      width: width,
      height: height,
      child: Material(
        textStyle: TextStyle(color: textColor, fontWeight: FontWeight.w500),
        color: Colors.transparent,
        shape: RoundedRectangleBorder(
            borderRadius: BorderRadius.circular(borderRadius)),
        child: InkWell(
          onTap: () => onPressed(),
          splashColor: const Color.fromARGB(0, 255, 94, 94),
          child: Padding(
            padding: const EdgeInsets.all(13),
            child: center
                ? Center(
                    child: child,
                  )
                : child,
          ),
          borderRadius: BorderRadius.circular(borderRadius),
        ),
      ),
    );
  }
}
